package io.modules.sys.controller;
import io.common.annotation.LogOperation;
import io.common.constant.Constant;
import io.modules.item.dto.SlidesDTO;

import io.modules.item.service.SlidesService;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


/**
 * 轮播图
 */
@RestController
@RequestMapping("sys/slides")
@Tag(name= "轮播图")
public class SlidesController {
    @Autowired
    private SlidesService slidesService;


    @Value("${upload.url}")
    private String uploadUrl;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })
    public Result<PageData<SlidesDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<SlidesDTO> page = slidesService.page(params);

        List<SlidesDTO> list = page.getList().stream().map(e -> {
            e.setPath(uploadUrl + e.getPath());
            return e;
        }).collect(Collectors.toList());

        page.setList(list);
        return new Result<PageData<SlidesDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")
    public Result<SlidesDTO> get(@PathVariable("id") Long id){
        SlidesDTO data = slidesService.get(id);

        return new Result<SlidesDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")
    @LogOperation("保存")
    public Result save(@RequestBody SlidesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        slidesService.save(dto);
        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")
    @LogOperation("修改")
    public Result update(@RequestBody SlidesDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);
        slidesService.update(dto);
        return new Result();
    }

    @DeleteMapping("{id}")
    @Operation(summary = "删除")
    @LogOperation("删除")
    public Result delete(@PathVariable Long id){

        Long[] ids = new Long[] { id };
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        slidesService.delete(ids);
        return new Result();
    }



}
